var React = require('react');

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var styles = {"main":"_S55cW","mainRow":"_A1KAp","mainCol":"_1fHYp"};

var DraggableArray = function DraggableArray(_ref) {
  var children = _ref.children,
      className = _ref.className,
      state = _ref.state,
      col = _ref.col,
      row = _ref.row;
  var childArr = [];
  React.Children.forEach(children, function (child) {
    return childArr.push(child);
  });

  var _useState = React.useState(state),
      externalState = _useState[0],
      setExternalState = _useState[1];

  var _useState2 = React.useState(),
      poppedItem = _useState2[0],
      setPoppedItem = _useState2[1];

  var _useState3 = React.useState(childArr),
      internalState = _useState3[0],
      setInternalState = _useState3[1];

  var _useState4 = React.useState(),
      draggedItem = _useState4[0],
      setDraggedItem = _useState4[1];

  var _useState5 = React.useState(),
      draggedOverItem = _useState5[0],
      setDraggedOverItem = _useState5[1];

  var _onDragStart = function onDragStart(e, index) {
    setDraggedItem(internalState[index]);
    e.dataTransfer.effectAllowed = 'move';
    e.dataTransfer.setData('text/html', e.target.parentNode);
    e.dataTransfer.setDragImage(e.target.parentNode, 40, 35);
    setPoppedItem(externalState[index]);
    var newExternalState = externalState;
    newExternalState.splice(index, 1);
    setExternalState(newExternalState);
  };

  var _onDragOver = function onDragOver(index) {
    setDraggedOverItem(internalState[index]);
    if (draggedItem === draggedOverItem) return;
    updateState(internalState, setInternalState, index, draggedItem);
    updateState(externalState, setExternalState, index, poppedItem);
  };

  var updateState = function updateState(state, setState, index, item) {
    var newState = state.filter(function (el) {
      return el !== item;
    });
    newState.splice(index, 0, item);
    setState(newState);
  };

  var _onDragEnd = function onDragEnd() {
    console.log(externalState);
    return externalState;
  };

  React.useEffect(function () {
    console.log(externalState);
  }, [externalState]);

  var renderChildren = function renderChildren(type, props, children, index) {
    var dragProps = {
      draggable: true,
      onDragStart: function onDragStart(e) {
        return _onDragStart(e, index);
      },
      onDragOver: function onDragOver() {
        return _onDragOver(index);
      },
      onDragEnd: function onDragEnd() {
        return _onDragEnd();
      }
    };

    if (children && typeof children !== 'string') {
      return React.Children.map(children, function (child) {
        return React.cloneElement(child, _extends({}, dragProps));
      });
    } else {
      return React.createElement(type, _extends({}, props, dragProps), children);
    }
  };

  var mainClassName = function mainClassName() {
    if (col) {
      return styles.mainCol + " " + className;
    } else if (row) {
      return styles.mainRow + " " + className;
    } else {
      return styles.main + " " + className;
    }
  };

  var childrenClassName = function childrenClassName(props) {
    if (children && typeof children !== 'string') {
      return styles.li + ' ' + props.className;
    } else {
      return styles.li;
    }
  };

  return React.createElement("div", {
    className: mainClassName()
  }, internalState.map(function (_ref2, index) {
    var type = _ref2.type,
        props = _ref2.props,
        children = _ref2.props.children;
    return React.createElement("li", {
      key: index,
      className: childrenClassName(props),
      style: children ? _extends({}, props.style) : {},
      draggable: true
    }, renderChildren(type, props, children, index));
  }));
};

module.exports = DraggableArray;
//# sourceMappingURL=index.js.map
